%This m-file is used for calculation and investigation of the term structure of yields%
clear all;

load ER_X_Y_at_t.mat
%Current exchange rate
ER_X_Y=ER_X_Y_at_t(3);
%Current time
t=ER_X_Y_at_t(1);
lasttime=ER_X_Y_at_t(2);

%COUNTRY X
%COUNTRY X with following values
load ValX.mat
r=ValX(1);
kappa=ValX(2);
theta=ValX(3);
sigma=ValX(4);
lambda=ValX(5);
gamma=((kappa+lambda)^2+2*(sigma^2))^0.5;
%Long term value of the yield
Rl=(2*kappa*theta)/(gamma+kappa+lambda)
%Critical value, which determines whether or not the term structure is humped
Rg=(kappa*theta)/(kappa+lambda)
phi1=gamma;
phi2=(kappa+lambda+gamma)*0.5;
phi3=(2*kappa*theta)/(sigma^2);

%This part calculates the term structure of default-free discount bonds accoding to the paper of CIRII
%Yield converges to the spot rate as maturity nears: Tau==Null
Rrt(1)=r;
i=1;    
for Tau=0.01:0.01:lasttime-t
    i=i+1;
    N=phi2*(exp(phi1*(Tau))-1)+phi1;    
    At=(phi1*exp(phi2*(Tau))/N)^phi3;
    Bt=(exp(phi1*(Tau))-1)/N;
    if At~=0
        Rrt(i)=(-log(At)+r*Bt)/(Tau);
    else
        Rrt(i)=NaN;
    end
end

Values=[t:0.01:lasttime;Rrt]; 
visu4=figure;
plot(Values(1,:),Values(2,:));hold on;

clear kappa theta sigma lambda gamma phi1 phi2 phi3 r Rrt Prt i;
  
%COUNTRY Y 
%COUNTRY Y with following values
load ValY.mat
r=ValY(1);
kappa=ValY(2);
theta=ValY(3);
sigma=ValY(4);
lambda=ValY(5);
gamma=((kappa+lambda)^2+2*(sigma^2))^0.5;
%Long term value of the yield
Rl=(2*kappa*theta)/(gamma+kappa+lambda)
%Critical value, which determines whether or not the term structure is humped
Rg=(kappa*theta)/(kappa+lambda)
phi1=gamma;
phi2=(kappa+lambda+gamma)*0.5;
phi3=(2*kappa*theta)/(sigma^2);

%This part calculates the term structure of default-free discount bonds accoding to the paper of CIRII
%Yield converges to the spot rate as maturity nears: Tau==Null
Rrt(1)=r;
i=1;    
for Tau=0.01:0.01:lasttime-t
    i=i+1;
    N=phi2*(exp(phi1*(Tau))-1)+phi1;    
    At=(phi1*exp(phi2*(Tau))/N)^phi3;
    Bt=(exp(phi1*(Tau))-1)/N;
    if At~=0
        Rrt(i)=(-log(At)+r*Bt)/(Tau);
    else
        Rrt(i)=NaN;
    end
end

Values=[t:0.01:lasttime;Rrt]; 
plot(Values(1,:),Values(2,:),'r');hold off;
%title(['VAL: ',texlabel('r='),mat2str(ValY(1)),';',texlabel('kappa='),mat2str(ValY(2)),';',texlabel('theta='),mat2str(ValY(3)),';',texlabel('sigma='),mat2str(ValY(4)),';',texlabel('lambda='),mat2str(ValY(5))],'Fontsize', 11);legend([texlabel('Rl='),mat2str(Rl),'; ',texlabel('Rg='),mat2str(Rg)],0);xlabel('Time-to-maturity');ylabel('Yield-to-maturity');grid on;
title(['VAL ONE: ',texlabel('r='),mat2str(ValX(1)),';',texlabel('kappa='),mat2str(ValX(2)),';',texlabel('theta='),mat2str(ValX(3)),';',texlabel('sigma='),mat2str(ValX(4)),';',texlabel('lambda='),mat2str(ValX(5)),' VAL TWO: ',texlabel('r='),mat2str(ValY(1)),';',texlabel('kappa='),mat2str(ValY(2)),';',texlabel('theta='),mat2str(ValY(3)),';',texlabel('sigma='),mat2str(ValY(4)),';',texlabel('lambda='),mat2str(ValY(5))],'Fontsize', 11);legend([texlabel('kappa='),mat2str(ValX(2))],[texlabel('kappa='),mat2str(ValY(2))],0);xlabel('Time-to-maturity');ylabel('Yield-to-maturity');grid on;

%SAVING OF PLOT with counting number i
i=9;
saveas(visu4,['termstructure',mat2str(i),'.eps']);
saveas(visu4,['termstructure',mat2str(i),'.fig']);

clear all;
